#include "asm.S"

        .set arch=loongson2f
        .set noreorder

rv40_rnd_table:
    .byte 0x00, 0x10, 0x20, 0x10
    .byte 0x20, 0x1C, 0x20, 0x1C
    .byte 0x00, 0x20, 0x10, 0x20
    .byte 0x20, 0x1C, 0x20, 0x1C

        .macro h264rv40_chroma_op_loongson name, avg=0
function \name\()_h264rv40_chroma_mc4
        .mask   0x00000000,0
        .fmask  0x00000000,0

        sll        $t1,  $t0,  16
        or         $t1,  $t1,  $t0
        mtc1       $t1,  $f16
        add        $t6,  $a1,  1

        mtc1       $0,   $f14
        mtc1       $0,   $f15
        lw         $t0,  16($sp)
        lw         $t1,  20($sp)
        mtc1       $t0,  $f4
        mtc1       $t1,  $f6
        li         $t2,  0x00080008
        li         $t4,  6
        mtc1       $t4,  $f18
        pshufh     $f16, $f16, $f14
        pshufh     $f18, $f18, $f14
        mtc1       $t2,  $f8
        mtc1       $t2,  $f9
        mtc1       $t2,  $f10
        mtc1       $t2,  $f11

        punpcklhw  $f4,  $f4,  $f4
        punpcklhw  $f6,  $f6,  $f6
        punpcklhw  $f4,  $f4,  $f4
        punpcklhw  $f6,  $f6,  $f6
        psubw      $f8,  $f8,  $f4
        psubw      $f10, $f10, $f6

        load_unaligned4 $a1, $f0,  $t0
        load_unaligned4 $t6, $f12, $t2
        add        $a1,  $a1,  $a2
        add        $t6,  $t6,  $a2
        punpcklbh  $f0,  $f0,  $f14
        punpcklbh  $f12, $f12, $f14
        pmullh     $f0,  $f0,  $f8
        pmullh     $f12, $f12, $f4
        paddh      $f12, $f12, $f0

1:      load_unaligned4 $a1, $f0, $t0
        load_unaligned4 $t6, $f2, $t2
        add        $a1,  $a1,  $a2
        add        $t6,  $t6,  $a2
        punpcklbh  $f0,  $f0,  $f14
        punpcklbh  $f2,  $f2,  $f14
        pmullh     $f0,  $f0,  $f8
        pmullh     $f2,  $f2,  $f4
        paddh      $f2,  $f2,  $f0
        mov.d      $f0,  $f2
        pmullh     $f12, $f12, $f10
        pmullh     $f2,  $f2,  $f6
        paddh      $f12, $f12, $f16
        paddh      $f2,  $f2,  $f12
        psrlh      $f2,  $f2,  $f18
        packushb   $f2,  $f2,  $f2
.if \avg
        lw         $t2, ($a0)
        mtc1       $t2,  $f12
        pavgb      $f2,  $f2,  $f12
.endif
        mfc1       $t0,  $f2
        sw         $t0, ($a0)
        add        $a0,  $a0,  $a2

        load_unaligned4 $a1, $f12, $t0
        load_unaligned4 $t6, $f2,  $t2
        add        $a1,  $a1,  $a2
        add        $t6,  $t6,  $a2
        punpcklbh  $f2,  $f2,  $f14
        punpcklbh  $f12, $f12, $f14
        pmullh     $f2,  $f2,  $f4
        pmullh     $f12, $f12, $f8
        paddh      $f2,  $f2,  $f12
        mov.d      $f12, $f2
        pmullh     $f0,  $f0,  $f10
        pmullh     $f2,  $f2,  $f6
        paddh      $f0,  $f0,  $f16
        paddh      $f2,  $f2,  $f0
        psrlh      $f2,  $f2,  $f18
        packushb   $f2,  $f2,  $f2
.if \avg
        lw         $t2, ($a0)
        mtc1       $t2,  $f0
        pavgb      $f2,  $f2,  $f0
.endif
        mfc1       $t0,  $f2
        addi       $a3,  $a3,  -2
        sw         $t0, ($a0)
        bgtz       $a3,  1b
        add        $a0,  $a0,  $a2
        j          $31
        nop
.end \name\()_h264rv40_chroma_mc4

function \name\()_h264_chroma_mc4_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        li  $t0, 32
        b   \name\()_h264rv40_chroma_mc4
        nop
.end \name\()_h264_chroma_mc4_loongson


function \name\()_rv40_chroma_mc4_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        lw  $t1, 16($sp)
        lw  $t2, 20($sp)
        sra $t1, $t1, 1
        sra $t2, $t2, 1
        sll $t2, $t2, 2
        add $t0, $t1, $t2
        lb  $t0, (rv40_rnd_table)($t0)
        b   \name\()_h264rv40_chroma_mc4
        nop
.end \name\()_rv40_chroma_mc4_loongson


function \name\()_h264rv40_chroma_mc8
        .mask   0x00000000,0
        .fmask  0x00000000,0

        sll        $t1,  $t0,  16
        or         $t1,  $t1,  $t0
        mtc1       $t1,  $f16
        mtc1       $t1,  $f17

        mtc1       $0,   $f14
        mtc1       $0,   $f15
        li         $t2,  0x00080008
        mtc1       $t2,  $f8
        mtc1       $t2,  $f9
        li         $t2,  3
        mtc1       $t2,  $f18
        li         $t3,  6
        mtc1       $t3,  $f20
        li         $t2,  0x00400040
        mtc1       $t2,  $f30
        mtc1       $t2,  $f31

        lw         $t0,  16($sp)
        lw         $t1,  20($sp)

        bgtz       $t0,  2f
        nop
        bgtz       $t1,  2f
        nop

1:      /* no filter needed */
        ldr        $t2,  0($a1)
        ldl        $t2,  7($a1)
.if \avg
        dmtc1      $t2,  $f0
        ld         $t4, ($a0)
        dmtc1      $t4,  $f2
        pavgb      $f0,  $f0,  $f2
        dmfc1      $t2,  $f0
.endif
        sd         $t2, ($a0)
        addi       $a3,  $a3,  -1
        add        $a1,  $a1,  $a2
        bgtz       $a3,  1b
        add        $a0,  $a0,  $a2
        j          $31
        nop

2:      blez       $t1,  1f
        li         $t9,  1
        blez       $t0,  1f
        move       $t9,  $a2
        b          3f
        nop
1:      /* 1-dimensional filter only */
        add        $t8,  $a1,  $t9
        add        $t0,  $t0,  $t1
        mtc1       $t0,  $f10
        psrlh      $f12, $f16, $f18
        pshufh     $f10, $f10, $f14
        psubh      $f8,  $f8,  $f10
2:      load_unaligned $a1, $f0, $t2
        load_unaligned $t8, $f4, $t4
        punpckhbh  $f2,  $f0,  $f14
        punpcklbh  $f0,  $f0,  $f14
        punpckhbh  $f6,  $f4,  $f14
        punpcklbh  $f4,  $f4,  $f14
        pmullh     $f0,  $f0,  $f8
        pmullh     $f2,  $f2,  $f8
        pmullh     $f4,  $f4,  $f10
        pmullh     $f6,  $f6,  $f10
        paddh      $f0,  $f0,  $f12
        paddh      $f2,  $f2,  $f12
        paddh      $f0,  $f0,  $f4
        paddh      $f2,  $f2,  $f6
        psrlh      $f0,  $f0,  $f18
        psrlh      $f2,  $f2,  $f18
        packushb   $f0,  $f0,  $f2
.if \avg
        ld         $t4, ($a0)
        dmtc1      $t4,  $f26
        pavgb      $f0,  $f0,  $f26
.endif
        dmfc1      $t2,  $f0
        sd         $t2,  0($a0)
        addi       $a3,  $a3,  -1
        add        $a1,  $a1,  $a2
        add        $a0,  $a0,  $a2
        bgtz       $a3,  2b
        add        $t8,  $t8,  $a2
        j          $31
        nop

3:      /* general case, bilinear */
        add        $t8,  $a1,  1
        mtc1       $t0,  $f8
        mtc1       $t1,  $f12
        pshufh     $f8,  $f8,  $f14
        pshufh     $f12, $f12, $f14
        psllh      $f10, $f8,  $f18
        pmullh     $f8,  $f8,  $f12
        psllh      $f12, $f12, $f18
        paddh      $f28, $f10, $f12
        mov.d      $f22, $f8
        psubh      $f10, $f10, $f8
        psubh      $f12, $f12, $f8
        paddh      $f8,  $f8,  $f30
        psubh      $f8,  $f8,  $f28
        mov.d      $f24, $f8
        load_unaligned $a1, $f0, $t0
        load_unaligned $t8, $f2, $t2

2:      add        $a1,  $a1,  $a2
        add        $t8,  $t8,  $a2
        punpcklbh  $f4,  $f0,  $f14
        punpckhbh  $f0,  $f0,  $f14
        punpckhbh  $f6,  $f2,  $f14
        punpcklbh  $f2,  $f2,  $f14
        pmullh     $f0,  $f0,  $f24
        pmullh     $f4,  $f4,  $f24
        pmullh     $f2,  $f2,  $f10
        pmullh     $f6,  $f6,  $f10
        paddh      $f4,  $f4,  $f2
        paddh      $f6,  $f6,  $f0
        load_unaligned $a1, $f26, $t0
        punpckhbh  $f2,  $f26, $f14
        punpcklbh  $f0,  $f26, $f14
        pmullh     $f0,  $f0,  $f12
        pmullh     $f2,  $f2,  $f12
        paddh      $f4,  $f4,  $f0
        paddh      $f6,  $f6,  $f2
        load_unaligned $t8, $f2, $t0
        punpckhbh  $f8,  $f2,  $f14
        punpcklbh  $f0,  $f2,  $f14
        pmullh     $f0,  $f0,  $f22
        pmullh     $f8,  $f8,  $f22
        paddh      $f4,  $f4,  $f0
        paddh      $f6,  $f6,  $f8
        mov.d      $f0,  $f26
        paddh      $f4,  $f4,  $f16
        paddh      $f6,  $f6,  $f16
        psrlh      $f4,  $f4,  $f20
        psrlh      $f6,  $f6,  $f20
        packushb   $f4,  $f4,  $f6
.if \avg
        ld         $t4, ($a0)
        dmtc1      $t4,  $f26
        pavgb      $f4,  $f4,  $f26
.endif
        dmfc1      $t2,  $f4
        sd         $t2,  0($a0)
        add        $a3,  $a3,  -1
        bgtz       $a3,  2b
        add        $a0,  $a0,  $a2
        j          $31
.end \name\()_h264rv40_chroma_mc8

function \name\()_h264_chroma_mc8_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        li  $t0, 32
        b   \name\()_h264rv40_chroma_mc8
        nop
.end \name\()_h264_chroma_mc8_loongson

function \name\()_no_rnd_vc1_chroma_mc8_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        li  $t0, 28
        b   \name\()_h264rv40_chroma_mc8
        nop
.end \name\()_no_rnd_vc1_chroma_mc8_loongson

function \name\()_rv40_chroma_mc8_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        lw  $t1, 16($sp)
        lw  $t2, 20($sp)
        sra $t1, $t1,    1
        sra $t2, $t2,    1
        sll $t2, $t2,    2
        add $t0, $t1,    $t2
        lb  $t0, (rv40_rnd_table)($t0)
        b   \name\()_h264rv40_chroma_mc8
        nop
.end \name\()_rv40_chroma_mc8_loongson
        .endm

h264rv40_chroma_op_loongson put, 0
h264rv40_chroma_op_loongson avg, 1

