#include "asm.S"

        .set arch=loongson2f
        .set noreorder

.macro int16_vector_op name, op
function \name
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

1:      ldr     $8,    0($a1)
        ldl     $8,    7($a1)
        dmtc1   $8,   $f16
        ldr     $9,    8($a1)
        ldl     $9,   15($a1)
        dmtc1   $9,   $f14
        ldr     $10,  16($a1)
        ldl     $10,  23($a1)
        dmtc1   $10,  $f12
        ldr     $11,  24($a1)
        ldl     $11,  31($a1)
        dmtc1   $11,  $f10

        ldc1    $f8,   0($a0)
        ldc1    $f4,   8($a0)
        ldc1    $f2,  16($a0)
        ldc1    $f0,  24($a0)

        \op     $f7,  $f8,    $f16
        \op     $f5,  $f4,    $f14
        \op     $f3,  $f2,    $f12
        \op     $f1,  $f0,    $f10

        sdc1    $f7,   0($a0)
        sdc1    $f5,   8($a0)
        sdc1    $f3,  16($a0)
        sdc1    $f1,  24($a0)

        addiu   $a2,  $a2,    -16
        addiu   $a1,  $a1,     32
        bgtz    $a2,  1b
        addiu   $a0,  $a0,     32

        j       $31
        nop
.end \name
        .endm

int16_vector_op add_int16_loongson, paddh
int16_vector_op sub_int16_loongson, psubh

function scalarproduct_int16_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0
        dmtc1   $0,   $f26
        dmtc1   $0,   $f27
        dmtc1   $0,   $f28
        dmtc1   $0,   $f29

1:      ldr     $8,    0($a0)
        ldl     $8,    7($a0)
        dmtc1   $8,   $f16
        ldr     $9,    8($a0)
        ldl     $9,   15($a0)
        dmtc1   $9,   $f14
        ldr     $10,  16($a0)
        ldl     $10,  23($a0)
        dmtc1   $10,  $f12
        ldr     $11,  24($a0)
        ldl     $11,  31($a0)
        dmtc1   $11,  $f10

        ldc1    $f8,   0($a1)
        ldc1    $f6,   8($a1)
        ldc1    $f4,  16($a1)
        ldc1    $f2,  24($a1)

        pmaddhw $f18, $f8,  $f16
        pmaddhw $f20, $f6,  $f14
        pmaddhw $f22, $f4,  $f12
        pmaddhw $f24, $f2,  $f10
        paddw   $f26, $f26, $f18
        paddw   $f28, $f28, $f20
        paddw   $f26, $f26, $f22
        paddw   $f28, $f28, $f24

        addiu   $a2,  $a2,  -16
        addiu   $a1,  $a1,   32
        bgtz    $a2,  1b
        addiu   $a0,  $a0,   32

        paddw   $f4,  $f26, $f28
        dli     $8,   0x4E
        mtc1    $8,   $f0
        pshufh  $f6,  $f4,  $f0
        paddw   $f4,  $f4,  $f6
        mfc1    $v0,  $f4

        j       $31
        nop
.end scalarproduct_int16_loongson

