#include "asm.S"

        .set arch=loongson2f
        .set noreorder

.macro PUT_OP  dta, out, tmp, avg=0, qsize=0
.if \avg
    .if \qsize
        ld       $t0,  \out
        dmtc1    $t0,  \tmp
        pavgb    $f10, $f10, \tmp
    .else
        lw       $t0,  \out
        mtc1     $t0,  \tmp
        pavgb    $f10, $f10, \tmp
    .endif
.endif
.if \qsize
        dmfc1    $t0,  $f10
        sd       $f10, \out
.else
        mfc1     $t0,  $f10
        sw       $f10, \out
.endif
.endm

/*
 * $f30 = 0003000300030003
 * $f28 = 0014001400140014
 * $f26 = 5
 * $f24 = rounder
 */
.macro QPEL_PREPARE, no_rnd=0
.if \no_rnd
        li        $t0,  0x00100010
.else
        li        $t0,  0x000F000F
.endif
        mtc1      $t0,  $f24
        mtc1      $t0,  $f25
        li        $t1,  5
        mtc1      $t1,  $f26
        li        $t0,  0x00140014
        mtc1      $t0,  $f28
        mtc1      $t0,  $f29
        li        $t1,  0x00030003
        mtc1      $t1,  $f30
        mtc1      $t1,  $f31
.endm

.macro QPEL_FILTER s0, s1, s2, s3, s4, t0, t1, t2, t3
        paddh    \t0,  \s0,  \s1
        paddh    \t3,  \s0,  \s2
        paddh    \t1,  \s1,  \s3
        paddh    \t3,  \t3,  \t3
        paddh    \t2,  \s2,  \s4
        psubh    \t3,  \t1,  \t3
        pmullh   \t0,  \t0,  $f28
        paddh    \t2,  \t2,  $f24
        pmullh   \t3,  \t3,  $f30
        paddh    \t0,  \t0,  \t2
        paddh    \t0,  \t0,  \t3
        psrah    \t0,  \t0,  $f26
        packushb \t0,  \t0,  \t0
.endm

.macro QPEL_V_LOW m3,m4,m5,m6, in0, in1, in2, in7, out, avg=0, qsize=0
        paddh    \m3,  \m3,  \m4
        pmullh   $f8,  \m3,  $f28
        ldr      $t0,  0+\in7
        ldl      $t0,  7+\in7
        dmtc1    $t0,  \m3
        ldr      $t2,  0+\in0
        ldl      $t2,  7+\in0
        dmtc1    $t2,  $f10
        paddh    $f10, $f10, \m3
        psubh    $f8,  $f8,  $f10
        ldr      $t0,  0+\in1
        ldl      $t0,  7+\in1
        dmtc1    $t0,  $f10
        ldr      $t2,  0+\in2
        ldl      $t2,  7+\in2
        dmtc1    $t2,  $f12
        QPEL_FILTER \m3,\m4,\m5,\m6, \in0, \in1, \in2, \in7
        PUT_OP   $f10, \out, $f14, \avg, \qsize
.endm

/* $f30 = 0x0014001400140014
 * $f28 = 0x0003000300030003
 * $f26 = rounder
 *
 * out = $f10
 */
$f0 = prev
.macro QPEL_H_LOW m3,m4,m5,m6, in0, in1, in2, in7, out, avg=0, qsize=0
        ldr       $t1,   0+\in0
        ldl       $t1,   7+\in0
        dmtc1     $t1,  \d0
        ldr       $t0,   2+\src
        ldl       $t0,   9+\src
        dmtc1     $t0,  \d1
        ldr       $t1,   3+\src
        ldl       $t1,  10+\src
        dmtc1     $t1,  \d2

        punpcklbh \d0,  \d0,  $f14
        punpckhbh \d1,  \d1,  $f14
        punpcklbh \d2,  \d2,  $f14
        paddh     $f8,  \d2,  \l1
        paddh     $f10, \d3,  \l2
        paddh     $f8,  $f8,  $f8
        psubh     $f10, $f10, $f8
        pmullh    $f10, $f10, $f28
        paddh     $f0,  $f0,  \l0
        paddh     $f6,  $f6,  \l3
        pmullh    $f6,  $f6,  $f30
        psubh     $f10, $f10, $f6
        paddh     $f6,  $f6,  $f26
        paddh     $f10, $f10, $f6
        li        $t0,  5
        mtc1      $t0,  $f0
        psraw     $f10, $f10, $f0
.endm

.macro QPEL_BASE opname, rounder, rnd, avg = 0, no_rnd = 0
function \opname\()mpeg4_qpel16_h_lowpass_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0
//(uint8_t *dst, uint8_t *src, int dstStride, int srcStride, int h){\

        lw        $t9,  16($sp) //h
        li        $t0,  0x90
        li        $t1,  0x41
        li        $t2,  0x06
        li        $t3,  0x05
        mtc1      $t0,  $f16
        mtc1      $t1,  $f18
        mtc1      $t2,  $f20
        mtc1      $t3,  $f22

.if \no_rnd
        li        $t0,  0x00100010
.else
        li        $t0,  0x000F000F
.endif
        mtc1      $t0,  $f24
        mtc1      $t0,  $f25
        li        $t1,  0x00140014
        mtc1      $t1,  $f26
        mtc1      $t1,  $f27
        li        $t0,  0x00030003
        mtc1      $t0,  $f28
        mtc1      $t0,  $f29

        mtc1      $0,   $f14
        mtc1      $0,   $f14
1:
        load_unaligned $a1, $f30, $t0
        punpckhbh $f2,  $f30, $f14
        punpcklbh $f0,  $f30, $f14
        pshufh    $f10, $f0,  $f16
        pshufh    $f12, $f0,  $f18
        ldr       $t0,  0+1($a1)
        ldl       $t0,  7+1($a1)
        dmtc1     $t0,  $f4
        ldr       $t2,  0+2($a1)
        ldl       $t2,  7+2($a1)
        dmtc1     $t2,  $f6
        ldr       $t0,  0+3($a1)
        ldl       $t0,  7+3($a1)
        dmtc1     $t0,  $f8
        punpckhbh $f4,  $f4,  $f14
        punpckhbh $f6,  $f6,  $f14
        punpckhbh $f8,  $f8,  $f14
        paddh     $f10, $f10, $f6
        paddh     $f12, $f12, $f4
        paddh     $f10, $f10, $f10
        psubh     $f12, $f12, $f10
        pshufh    $f10, $f0,  $f20
        pmullh    $f12, $f12, $f28
        paddh     $f0,  $f0,  $f8
        paddh     $f10, $f10, $f2
        pmullh    $f0,  $f0,  $f26
        psubh     $f0,  $f0,  $f10
        paddh     $f12, $f12, $f24
        paddh     $f0,  $f0,  $f12
        psrah     $f30, $f0,  $f22

        ldr       $t0,  0+5($a1)
        ldl       $t0,  7+5($a1)
        dmtc1     $t0,  $f12
        ldr       $t0,  0+6($a1)
        ldl       $t0,  7+6($a1)
        dmtc1     $t0,  $f0
        ldr       $t0,  0+7($a1)
        ldl       $t0,  7+7($a1)
        dmtc1     $t0,  $f10
        punpcklbh $f0,  $f0,  $f14
        punpcklbh $f10, $f10, $f14
        
        "paddw $f0, $f4               \n\t" /* b */\
        "paddw $f10, $f6               \n\t" /* c */\
        "paddw $f4, $f4               \n\t" /* 2b */\
        "psubw $f4, $f6               \n\t" /* c - 2b */\
        "movq $f12, $f4                \n\t" /* FGHIJKLM */\
        "psrlq $24, $f12                 \n\t" /* IJKLM000 */\
        "punpcklbw $f14, $f4           \n\t" /* 0F0G0H0I */\
        "punpcklbw $f14, $f12           \n\t" /* 0I0J0K0L */\
        "pmullw "MANGLE(ff_pw_3)", $f6  \n\t" /* 3c - 6b */\
        "paddw $f4, $f2               \n\t" /* a */\
        "paddw $f12, $f8               \n\t" /* d */\
        "pmullw "MANGLE(ff_pw_20)", $f2 \n\t" /* 20a */\
        "psubw $f8, $f6               \n\t" /* - 6b +3c - d */\
        "paddw %6, $f2                  \n\t"\
        "paddw $f2, $f6               \n\t" /* 20a - 6b +3c - d */\
        "psraw $5, $f6                  \n\t"\
        "movq $f30, $f2                   \n\t"\
        "packuswb $f6, $f2            \n\t"\
        OP_MMX2($f2, (%1),$f8, q)\
        /* mm0= GHIJ, mm2=FGHI, mm5=HIJK, mm6=IJKL, mm7=0 */\
        \
        "movq 9(%0), $f2                \n\t" /* JKLMNOPQ */\
        "movq $f2, $f8                \n\t" /* JKLMNOPQ */\
        "movq $f2, $f6                \n\t" /* JKLMNOPQ */\
        "psrlq $8, $f2                  \n\t" /* KLMNOPQ0 */\
        "psrlq $16, $f8                 \n\t" /* LMNOPQ00 */\
        "punpcklbw $f14, $f2           \n\t" /* 0K0L0M0N */\
        "punpcklbw $f14, $f8           \n\t" /* 0L0M0N0O */\
        "paddw $f2, $f10               \n\t" /* b */\
        "paddw $f8, $f0               \n\t" /* c */\
        "paddw $f10, $f10               \n\t" /* 2b */\
        "psubw $f10, $f0               \n\t" /* c - 2b */\
        "movq $f6, $f10                \n\t" /* JKLMNOPQ */\
        "psrlq $24, $f6                 \n\t" /* MNOPQ000 */\
        "pmullw "MANGLE(ff_pw_3)", $f0  \n\t" /* 3c - 6b */\
        "punpcklbw $f14, $f6           \n\t" /* 0M0N0O0P */\
        "paddw $f6, $f4               \n\t" /* d */\
        "psubw $f4, $f0               \n\t" /* -6b + 3c - d */\
        "movq $f10, $f4                \n\t" /* JKLMNOPQ */\
        "punpcklbw $f14, $f4           \n\t" /* 0J0K0L0M */\
        "punpckhbw $f14, $f10           \n\t" /* 0N0O0P0Q */\
        "paddw $f4, $f12               \n\t" /* a */\
        "pmullw "MANGLE(ff_pw_20)", $f12 \n\t" /* 20a */\
        "paddw %6, $f0                  \n\t"\
        "paddw $f12, $f0               \n\t" /* 20a - 6b + 3c - d */\
        "psraw $5, $f0                  \n\t"\
        /* mm1=KLMN, mm2=JKLM, mm3=MNOP, mm4=LMNO, mm5=NOPQ mm7=0 */\
        \
        "paddw $f10, $f6               \n\t" /* a */\
        "pshufw $0xF9, $f10, $f12       \n\t" /* 0O0P0Q0Q */\
        "paddw $f8, $f12               \n\t" /* b */\
        "pshufw $0xBE, $f10, $f8       \n\t" /* 0P0Q0Q0P */\
        "pshufw $0x6F, $f10, $f10       \n\t" /* 0Q0Q0P0O */\
        "paddw $f2, $f8               \n\t" /* c */\
        "paddw $f4, $f10               \n\t" /* d */\
        "paddw $f12, $f12               \n\t" /* 2b */\
        "psubw $f12, $f8               \n\t" /* c - 2b */\
        "pmullw "MANGLE(ff_pw_20)", $f6 \n\t" /* 20a */\
        "pmullw "MANGLE(ff_pw_3)", $f8  \n\t" /* 3c - 6b */\
        "psubw $f10, $f6               \n\t" /* -6b + 3c - d */\
        "paddw %6, $f8                  \n\t"\
        "paddw $f6, $f8               \n\t" /* 20a - 6b + 3c - d */\
        "psraw $5, $f8                  \n\t"\
        "packuswb $f8, $f0            \n\t"\
        OP_MMX2($f0, 8(%1), $f8, q)\
        \
        "add %3, %0                       \n\t"\
        "add %4, %1                       \n\t"\
        "decl %2                          \n\t"\
        " jnz 1b                          \n\t"\
        : "+a"(src), "+c"(dst), "+D"(h)\
        : "d"((x86_reg)srcStride), "S"((x86_reg)dstStride), /*"m"(ff_pw_20), "m"(ff_pw_3),*/ "m"(temp), "m"(ROUNDER)\
        : "memory"\
    );
.end \opname\()mpeg4_qpel16_h_lowpass_loongson

function \opname\()mpeg4_qpel8_h_lowpass_loongson

    __asm__ volatile(\
        "pxor $f14, $f14                \n\t"\
        "1:                               \n\t"\
        "movq  (%0), $f0                \n\t" /* ABCDEFGH */\
        "movq $f0, $f2                \n\t" /* ABCDEFGH */\
        "movq $f0, $f4                \n\t" /* ABCDEFGH */\
        "punpcklbw $f14, $f0           \n\t" /* 0A0B0C0D */\
        "punpckhbw $f14, $f2           \n\t" /* 0E0F0G0H */\
        "pshufw $0x90, $f0, $f10       \n\t" /* 0A0A0B0C */\
        "pshufw $0x41, $f0, $f12       \n\t" /* 0B0A0A0B */\
        "movq $f4, $f6                \n\t" /* ABCDEFGH */\
        "movq $f4, $f8                \n\t" /* ABCDEFGH */\
        "psllq $8, $f4                  \n\t" /* 0ABCDEFG */\
        "psllq $16, $f6                 \n\t" /* 00ABCDEF */\
        "psllq $24, $f8                 \n\t" /* 000ABCDE */\
        "punpckhbw $f14, $f4           \n\t" /* 0D0E0F0G */\
        "punpckhbw $f14, $f6           \n\t" /* 0C0D0E0F */\
        "punpckhbw $f14, $f8           \n\t" /* 0B0C0D0E */\
        "paddw $f6, $f10               \n\t" /* b */\
        "paddw $f4, $f12               \n\t" /* c */\
        "paddw $f10, $f10               \n\t" /* 2b */\
        "psubw $f10, $f12               \n\t" /* c - 2b */\
        "pshufw $0x06, $f0, $f10       \n\t" /* 0C0B0A0A */\
        "pmullw "MANGLE(ff_pw_3)", $f12  \n\t" /* 3c - 6b */\
        "paddw $f8, $f0               \n\t" /* a */\
        "paddw $f2, $f10               \n\t" /* d */\
        "pmullw "MANGLE(ff_pw_20)", $f0 \n\t" /* 20a */\
        "psubw $f10, $f0               \n\t" /* 20a - d */\
        "paddw %5, $f12                  \n\t"\
        "paddw $f12, $f0               \n\t" /* 20a - 6b + 3c - d */\
        "psraw $5, $f0                  \n\t"\
        /* mm1=EFGH, mm2=DEFG, mm3=CDEF, mm4=BCDE, mm7=0 */\
        \
        "movd 5(%0), $f10                \n\t" /* FGHI */\
        "punpcklbw $f14, $f10           \n\t" /* 0F0G0H0I */\
        "pshufw $0xF9, $f10, $f12       \n\t" /* 0G0H0I0I */\
        "paddw $f10, $f2               \n\t" /* a */\
        "paddw $f12, $f4               \n\t" /* b */\
        "pshufw $0xBE, $f10, $f12       \n\t" /* 0H0I0I0H */\
        "pshufw $0x6F, $f10, $f10       \n\t" /* 0I0I0H0G */\
        "paddw $f12, $f6               \n\t" /* c */\
        "paddw $f10, $f8               \n\t" /* d */\
        "paddw $f4, $f4               \n\t" /* 2b */\
        "psubw $f4, $f6               \n\t" /* c - 2b */\
        "pmullw "MANGLE(ff_pw_20)", $f2 \n\t" /* 20a */\
        "pmullw "MANGLE(ff_pw_3)", $f6  \n\t" /* 3c - 6b */\
        "psubw $f8, $f6               \n\t" /* -6b + 3c - d */\
        "paddw %5, $f2                  \n\t"\
        "paddw $f2, $f6               \n\t" /* 20a - 6b + 3c - d */\
        "psraw $5, $f6                  \n\t"\
        "packuswb $f6, $f0            \n\t"\
        OP_MMX2($f0, (%1), $f8, q)\
        \
        "add %3, %0                       \n\t"\
        "add %4, %1                       \n\t"\
        "decl %2                          \n\t"\
        " jnz 1b                          \n\t"\
        : "+a"(src), "+c"(dst), "+d"(h)\
        : "S"((x86_reg)srcStride), "D"((x86_reg)dstStride), /*"m"(ff_pw_20), "m"(ff_pw_3),*/ "m"(ROUNDER)\
        : "memory"\
    );\
}
.end .end \opname\()mpeg4_qpel8_h_lowpass_loongson
.endm

.macro QPEL_OP OPNAME, ROUNDER, RND, avg=0

function \OPNAME\()mpeg4_qpel16_v_lowpass_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0

        addiu     $t9,  $sp,  -544
        li        $t8,  17
        lw        $t6,  16($sp) //h

        xor       $f14, $f14, $f14
        move      $t7,  $t9
1:
        ldr       $t0,   0($a1)
        ldl       $t0,   7($a1)
        dmtc1     $t0,  $f2
        ldr       $t2,   8($a1)
        ldl       $t2,  15($a1)
        dmtc1     $t2,  $f4
        dmtc1     $t2,  $f6
        punpcklbh $f0,  $f0,  $f14
        punpcklbh $f2,  $f2,  $f14
        punpcklbh $f4,  $f4,  $f14
        punpcklbh $f6,  $f6,  $f14
        dmfc1     $t0,  $f0
        sd        $t0,  0*17*8($t9)
        dmfc1     $t2,  $f2
        sd        $t2,  1*17*8($t9)
        dmfc1     $t0,  $f4
        sd        $t0,  2*17*8($t9)
        dmfc1     $t2,  $f6
        sd        $t2,  3*17*8($t9)
        addiu     $t8,  $t8,  -1
        addiu     $t9,  $t9,   8
        bgtz      $t8,  1b
        add       $a1,  $a1,  $a3


        sll       $t6,  $a2,  3
        sub       $t6,  $a2,  $t6
        add       $t6,  $t6,  $t6
        addiu     $t6,  $t6,  4    // t6 = 4 - 14*a2
        li        $t8,  4

1:
        ld        $t0,    0($t7)
        ld        $t2,    8($t7)
        dmtc1     $t0,   $f0
        dmtc1     $t2,   $f2
        ld        $t0,   16($t7)
        ld        $t2,   24($t7)
        dmtc1     $t0,   $f4
        dmtc1     $t2,   $f6
        QPEL_V_LOW $f0, $f2, $f4, $f6, %5, 16(%0),  8(%0),   (%0), 32(%0), ($a0), avg
        QPEL_V_LOW $f2, $f4, $f6, $f0, %5,  8(%0),   (%0),   (%0), 40(%0), ($a0, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f4, $f6, $f0, $f2, %5,   (%0),   (%0),  8(%0), 48(%0), (%1), avg
        QPEL_V_LOW $f6, $f0, $f2, $f4, %5,   (%0),  8(%0), 16(%0), 56(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f0, $f2, $f4, $f6, %5,  8(%0), 16(%0), 24(%0), 64(%0), (%1), avg
        QPEL_V_LOW $f2, $f4, $f6, $f0, %5, 16(%0), 24(%0), 32(%0), 72(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f4, $f6, $f0, $f2, %5, 24(%0), 32(%0), 40(%0), 80(%0), (%1), avg
        QPEL_V_LOW $f6, $f0, $f2, $f4, %5, 32(%0), 40(%0), 48(%0), 88(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f0, $f2, $f4, $f6, %5, 40(%0), 48(%0), 56(%0), 96(%0), (%1), avg
        QPEL_V_LOW $f2, $f4, $f6, $f0, %5, 48(%0), 56(%0), 64(%0),104(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f4, $f6, $f0, $f2, %5, 56(%0), 64(%0), 72(%0),112(%0), (%1), avg
        QPEL_V_LOW $f6, $f0, $f2, $f4, %5, 64(%0), 72(%0), 80(%0),120(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f0, $f2, $f4, $f6, %5, 72(%0), 80(%0), 88(%0),128(%0), (%1), avg
        QPEL_V_LOW $f2, $f4, $f6, $f0, %5, 80(%0), 88(%0), 96(%0),128(%0), (%1, %3), avg
        add       $a0,   $a0,  $t6
        QPEL_V_LOW $f4, $f6, $f0, $f2, %5, 88(%0), 96(%0),104(%0),120(%0), (%1), avg
        QPEL_V_LOW $f6, $f0, $f2, $f4, %5, 96(%0),104(%0),112(%0),112(%0), (%1, %3), avg
        addiu     $t8,   $t8,  -1
        addiu     $t7,   $t7,  136
        bgtz      $t8,   1b
        add       $a0,   $a0,  $a2
        j         $31
.end function \OPNAME\()mpeg4_qpel16_v_lowpass_loongson


function \OPNAME\()mpeg4_qpel8_v_lowpass_loongson
        .frame  $sp,0,$31
        .mask   0x00000000,0
        .fmask  0x00000000,0
    uint64_t temp[9*2];\
    uint64_t *temp_ptr= temp;\
    int count= 9;\
\
    /*FIXME unroll */\
    __asm__ volatile(\
        "pxor $f14, $f14              \n\t"\
        "1:                             \n\t"\
        "movq (%0), $f0               \n\t"\
        "movq (%0), $f2               \n\t"\
        "punpcklbw $f14, $f0         \n\t"\
        "punpckhbw $f14, $f2         \n\t"\
        "movq $f0, (%1)               \n\t"\
        "movq $f2, 9*8(%1)            \n\t"\
        "add $8, %1                     \n\t"\
        "add %3, %0                     \n\t"\
        "decl %2                        \n\t"\
        " jnz 1b                        \n\t"\
        : "+r" (src), "+r" (temp_ptr), "+r"(count)\
        : "r" ((x86_reg)srcStride)\
        : "memory"\
    );\
    \
    temp_ptr= temp;\
    count=2;\
    \
/*FIXME reorder for speed */\
    __asm__ volatile(\
        /*"pxor $f14, $f14              \n\t"*/\
        "1:                             \n\t"\
        "movq (%0), $f0               \n\t"\
        "movq 8(%0), $f2              \n\t"\
        "movq 16(%0), $f4             \n\t"\
        "movq 24(%0), $f6             \n\t"\
        QPEL_V_LOW($f0, $f2, $f4, $f6, %5, %6, %5, 16(%0),  8(%0),   (%0), 32(%0), (%1), OP)\
        QPEL_V_LOW($f2, $f4, $f6, $f0, %5, %6, %5,  8(%0),   (%0),   (%0), 40(%0), (%1, %3), OP)\
        "add %4, %1                     \n\t"\
        QPEL_V_LOW($f4, $f6, $f0, $f2, %5, %6, %5,   (%0),   (%0),  8(%0), 48(%0), (%1), OP)\
        \
        QPEL_V_LOW($f6, $f0, $f2, $f4, %5, %6, %5,   (%0),  8(%0), 16(%0), 56(%0), (%1, %3), OP)\
        "add %4, %1                     \n\t"\
        QPEL_V_LOW($f0, $f2, $f4, $f6, %5, %6, %5,  8(%0), 16(%0), 24(%0), 64(%0), (%1), OP)\
        \
        QPEL_V_LOW($f2, $f4, $f6, $f0, %5, %6, %5, 16(%0), 24(%0), 32(%0), 64(%0), (%1, %3), OP)\
        "add %4, %1                     \n\t"\
        QPEL_V_LOW($f4, $f6, $f0, $f2, %5, %6, %5, 24(%0), 32(%0), 40(%0), 56(%0), (%1), OP)\
        QPEL_V_LOW($f6, $f0, $f2, $f4, %5, %6, %5, 32(%0), 40(%0), 48(%0), 48(%0), (%1, %3), OP)\
                \
        "add $72, %0                    \n\t"\
        "add %6, %1                     \n\t"\
        "decl %2                        \n\t"\
        " jnz 1b                        \n\t"\
         \
        : "+r"(temp_ptr), "+r"(dst), "+g"(count)\
        : "r"((x86_reg)dstStride), "r"(2*(x86_reg)dstStride), /*"m"(ff_pw_20), "m"(ff_pw_3),*/ "m"(ROUNDER), "g"(4-6*(x86_reg)dstStride)\
        : "memory"\
   );\
.end \OPNAME\()mpeg4_qpel16_v_lowpass_loongson


static void OPNAME ## qpel8_mc00_loongson (uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## pixels8_loongson(dst, src, stride, 8);\
}\
\
static void OPNAME ## qpel8_mc10_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[8];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(half, src, 8, stride, 8);\
    OPNAME ## pixels8_l2_loongson(dst, src, half, stride, stride, 8);\
}\
\
static void OPNAME ## qpel8_mc20_loongson(uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## mpeg4_qpel8_h_lowpass_loongson(dst, src, stride, stride, 8);\
}\
\
static void OPNAME ## qpel8_mc30_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[8];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(half, src, 8, stride, 8);\
    OPNAME ## pixels8_l2_loongson(dst, src+1, half, stride, stride, 8);\
}\
\
static void OPNAME ## qpel8_mc01_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[8];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(half, src, 8, stride);\
    OPNAME ## pixels8_l2_loongson(dst, src, half, stride, stride, 8);\
}\
\
static void OPNAME ## qpel8_mc02_loongson(uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## mpeg4_qpel8_v_lowpass_loongson(dst, src, stride, stride);\
}\
\
static void OPNAME ## qpel8_mc03_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[8];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(half, src, 8, stride);\
    OPNAME ## pixels8_l2_loongson(dst, src+stride, half, stride, stride, 8);\
}\
static void OPNAME ## qpel8_mc11_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src, halfH, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc31_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src+1, halfH, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc13_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src, halfH, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH+8, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc33_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src+1, halfH, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH+8, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc21_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc23_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half) + 64;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## mpeg4_qpel8_v_lowpass_loongson(halfHV, halfH, 8, 8);\
    OPNAME ## pixels8_l2_loongson(dst, halfH+8, halfHV, stride, 8, 8);\
}\
static void OPNAME ## qpel8_mc12_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src, halfH, 8, stride, 9);\
    OPNAME ## mpeg4_qpel8_v_lowpass_loongson(dst, halfH, stride, 8);\
}\
static void OPNAME ## qpel8_mc32_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[8 + 9];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    put ## RND ## pixels8_l2_loongson(halfH, src+1, halfH, 8, stride, 9);\
    OPNAME ## mpeg4_qpel8_v_lowpass_loongson(dst, halfH, stride, 8);\
}\
static void OPNAME ## qpel8_mc22_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[9];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel8_h_lowpass_loongson(halfH, src, 8, stride, 9);\
    OPNAME ## mpeg4_qpel8_v_lowpass_loongson(dst, halfH, stride, 8);\
}\
static void OPNAME ## qpel16_mc00_loongson (uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## pixels16_loongson(dst, src, stride, 16);\
}\
\
static void OPNAME ## qpel16_mc10_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[32];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(half, src, 16, stride, 16);\
    OPNAME ## pixels16_l2_loongson(dst, src, half, stride, stride, 16);\
}\
\
static void OPNAME ## qpel16_mc20_loongson(uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## mpeg4_qpel16_h_lowpass_loongson(dst, src, stride, stride, 16);\
}\
\
static void OPNAME ## qpel16_mc30_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[32];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(half, src, 16, stride, 16);\
    OPNAME ## pixels16_l2_loongson(dst, src+1, half, stride, stride, 16);\
}\
\
static void OPNAME ## qpel16_mc01_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[32];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(half, src, 16, stride);\
    OPNAME ## pixels16_l2_loongson(dst, src, half, stride, stride, 16);\
}\
\
static void OPNAME ## qpel16_mc02_loongson(uint8_t *dst, uint8_t *src, int stride){\
    OPNAME ## mpeg4_qpel16_v_lowpass_loongson(dst, src, stride, stride);\
}\
\
static void OPNAME ## qpel16_mc03_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t temp[32];\
    uint8_t * const half= (uint8_t*)temp;\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(half, src, 16, stride);\
    OPNAME ## pixels16_l2_loongson(dst, src+stride, half, stride, stride, 16);\
}\
static void OPNAME ## qpel16_mc11_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src, halfH, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc31_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src+1, halfH, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc13_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src, halfH, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH+16, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc33_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src+1, halfH, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH+16, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc21_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc23_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[16*2 + 17*2];\
    uint8_t * const halfH= ((uint8_t*)half) + 256;\
    uint8_t * const halfHV= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## mpeg4_qpel16_v_lowpass_loongson(halfHV, halfH, 16, 16);\
    OPNAME ## pixels16_l2_loongson(dst, halfH+16, halfHV, stride, 16, 16);\
}\
static void OPNAME ## qpel16_mc12_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[17*2];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src, halfH, 16, stride, 17);\
    OPNAME ## mpeg4_qpel16_v_lowpass_loongson(dst, halfH, stride, 16);\
}\
static void OPNAME ## qpel16_mc32_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[17*2];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    put ## RND ## pixels16_l2_loongson(halfH, src+1, halfH, 16, stride, 17);\
    OPNAME ## mpeg4_qpel16_v_lowpass_loongson(dst, halfH, stride, 16);\
}\
static void OPNAME ## qpel16_mc22_loongson(uint8_t *dst, uint8_t *src, int stride){\
    uint64_t half[17*2];\
    uint8_t * const halfH= ((uint8_t*)half);\
    put ## RND ## mpeg4_qpel16_h_lowpass_loongson(halfH, src, 16, stride, 17);\
    OPNAME ## mpeg4_qpel16_v_lowpass_loongson(dst, halfH, stride, 16);\
}

.endm

#define PUT_OP(a,b,temp, size) "mov" #size " " #a ", " #b "        \n\t"
#define AVG_MMX2_OP(a,b,temp, size) \
"mov" #size " " #b ", " #temp "   \n\t"\
"pavgb " #temp ", " #a "          \n\t"\
"mov" #size " " #a ", " #b "      \n\t"

//QPEL_BASE put_       , ff_pw_16, _
//QPEL_BASE(avg_       , ff_pw_16, _       , AVG_MMX2_OP, AVG_3DNOW_OP)
//QPEL_BASE(put_no_rnd_, ff_pw_15, _no_rnd_, PUT_OP, PUT_OP)
QPEL_OP put_       , ff_pw_16, _       , 0
//QPEL_OP(avg_       , ff_pw_16, _       , AVG_MMX2_OP, mmx2)
//QPEL_OP(put_no_rnd_, ff_pw_15, _no_rnd_, PUT_OP, mmx2)

