/*
 * Simple IDCT MMX
 *
 * Copyright (c) 2001, 2002 Michael Niedermayer <michaelni@gmx.at>
 *
 * This file is part of FFmpeg.
 *
 * FFmpeg is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * FFmpeg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FFmpeg; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#include "asm.S"

        .set arch=loongson2f
        .set noreorder

.macro ROW_IDCT src0, src4, src1, src5, dst
        ld       $t0,  \src0
        dmtc1    $t0,  $f0
        ld       $t2,  \src4
        dmtc1    $t2,  $f2
        ld       $t0,  \src1
        dmtc1    $t0,  $f4
        ld       $t2,  \src5
        dmtc1    $t2,  $f6
        ld       $t0,  16($t9)
        dmtc1    $t0,  $f8
        pmaddhw  $f8,  $f8,  $f0
        ld       $t2,  24($t9)
        dmtc1    $t2,  $f10
        pmaddhw  $f0,  $f0,  $f10
        ld       $t0,  32($t9)
        dmtc1    $t0,  $f10
        pmaddhw  $f10, $f10, $f2
        ld       $t2,  40($t9)
        dmtc1    $t2,  $f12
        pmaddhw  $f2,  $f2,  $f12
        ld       $t0,  48($t9)
        dmtc1    $t0,  $f14
        pmaddhw  $f14, $f14, $f4
        ld       $t2,  8($t9)
        dmtc1    $t2,  $f16
        paddw    $f8,  $f8,  $f16
        psubw    $f12, $f8,  $f10
        paddw    $f8,  $f8,  $f10
        ld       $t0,  56($t9)
        dmtc1    $t0,  $f10
        pmaddhw  $f10, $f10, $f6
        paddw    $f0,  $f0,  $f16
        paddw    $f2,  $f2,  $f0
        paddw    $f0,  $f0,  $f0
        psubw    $f0,  $f0,  $f2
        ld       $t0,  64($t9)
        dmtc1    $t0,  $f16
        pmaddhw  $f4,  $f4,  $f16
        paddw    $f14, $f14, $f10
        ld       $t2,  72($t9)
        dmtc1    $t2,  $f10
        pmaddhw  $f10, $f10, $f6
        paddw    $f14, $f14, $f8
        paddw    $f8,  $f8,  $f8
        psubw    $f8,  $f8,  $f14
        paddw    $f10, $f10, $f4
        psraw    $f14, $f14, $f18
        psraw    $f8,  $f8,  $f18
        psubw    $f4,  $f2,  $f10
        paddw    $f2,  $f2,  $f10
        psraw    $f4,  $f4,  $f18
        psraw    $f2,  $f2,  $f18
        packsswh $f14, $f14, $f2
        packsswh $f4,  $f4,  $f8
        dmfc1    $t0,  $f14
        sd       $t0,  \dst
        ld       $t2,  \src1
        dmtc1    $t2,  $f2
        ld       $t4,  80($t9)
        dmtc1    $t4,  $f8
        dmfc1    $t0,  $f4
        sd       $t0,  24+\dst
        pmaddhw  $f8,  $f8,  $f2
        ld       $t2,  88($t9)
        dmtc1    $t2,  $f14
        ld       $t4,  96($t9)
        dmtc1    $t4,  $f20
        pmaddhw  $f2,  $f2,  $f20
        pmaddhw  $f14, $f14, $f6
        ld       $t2,  104($t9)
        dmtc1    $t2,  $f20
        pmaddhw  $f6,  $f6,  $f20
        paddw    $f8,  $f8,  $f14
        paddw    $f4,  $f0,  $f8
        psubw    $f0,  $f0,  $f8
        psraw    $f4,  $f4,  $f18
        psraw    $f0,  $f0,  $f18
        paddw    $f6,  $f6,  $f2
        psubw    $f8,  $f12, $f6
        paddw    $f12, $f12, $f6
        psraw    $f12, $f12, $f18
        packsswh $f4,  $f4,  $f12
        dmfc1    $t0,  $f4
        sd       $t0,  8+\dst
        psraw    $f8,  $f8,  $f18
        packsswh $f8,  $f8,  $f0
        dmfc1    $t2,  $f8
        sd       $t2,  16+\dst
.endm

.macro COL_IDCT src0, src4, src1, src5, dst, shift
        ld       $t0,  \src0
        ld       $t2,  \src4
        ld       $t4,  \src1
        ld       $t6,  \src5
        dmtc1    $t0,  $f0
        dmtc1    $t2,  $f2
        dmtc1    $t4,  $f4
        dmtc1    $t6,  $f6
        ld       $t0,  16($t9)
        dmtc1    $t0,  $f8
        pmaddhw  $f8,  $f8,  $f0
        ld       $t2,  24($t9)
        dmtc1    $t2,  $f10
        pmaddhw  $f0,  $f0,  $f10
        ld       $t0,  32($t9)
        dmtc1    $t0,  $f10
        pmaddhw  $f10, $f10,  $f2
        ld       $t2,  40($t9)
        dmtc1    $t2,  $f12
        pmaddhw  $f2,  $f2,  $f12
        ld       $t0,  48($t9)
        dmtc1    $t0,  $f14
        pmaddhw  $f14, $f14, $f4
        psubw    $f12, $f8,  $f10
        paddw    $f8,  $f8,  $f10
        psubw    $f10, $f0,  $f2
        paddw    $f0,  $f0,  $f2
        ld       $t2,  56($t9)
        dmtc1    $t2,  $f2
        pmaddhw  $f2,  $f2,  $f6
        ld       $t0,  64($t9)
        dmtc1    $t0,  $f16
        pmaddhw  $f4,  $f4,  $f16
        paddw    $f14, $f14, $f2
        ld       $t2,  72($t9)
        dmtc1    $t2,  $f2
        pmaddhw  $f2,  $f2,  $f6
        paddw    $f14, $f14, $f8
        paddw    $f8,  $f8,  $f8
        psubw    $f8,  $f8,  $f14
        paddw    $f2,  $f2,  $f4
        psraw    $f14, $f14, $f18
        psraw    $f8,  $f8,  $f18
        psubw    $f4,  $f0,  $f2
        paddw    $f0,  $f0,  $f2
        psraw    $f4,  $f4,  $f18
        psraw    $f0,  $f0,  $f18
        packsswh $f14, $f14, $f14
        mfc1     $t0,  $f14
        sw       $t0,  \dst
        packsswh $f0,  $f0,  $f0
        mfc1     $t2,  $f0
        sw       $t2,  16+\dst
        packsswh $f4,  $f4,  $f4
        mfc1     $t0,  $f4
        sw       $t0,  96+\dst
        packsswh $f8,  $f8,  $f8
        mfc1     $t2,  $f8
        sw       $t2,  112+\dst
        ld       $t0,  \src1
        dmtc1    $t0,  $f0
        ld       $t2,  80($t9)
        dmtc1    $t2,  $f8
        pmaddhw  $f8,  $f8,  $f0
        ld       $t0,  88($t9)
        dmtc1    $t0,  $f14
        ld       $t2,  96($t9)
        dmtc1    $t2,  $f16
        pmaddhw  $f14, $f14, $f6
        pmaddhw  $f0,  $f0,  $f16
        ld       $t0,  104($t9)
        dmtc1    $t0,  $f16
        paddw    $f8,  $f8,  $f14
        pmaddhw  $f6,  $f6,  $f16
        paddw    $f4,  $f10, $f8
        psubw    $f10, $f10, $f8
        psraw    $f4,  $f4,  $f18
        psraw    $f10, $f10, $f18
        paddw    $f6,  $f6,  $f0
        psubw    $f8,  $f12, $f6
        paddw    $f12, $f12, $f6
        psraw    $f8,  $f8,  $f18
        psraw    $f12, $f12, $f18
        packsswh $f4,  $f4,  $f4
        packsswh $f12, $f12, $f12
        mfc1     $t0,  $f4
        mfc1     $t2,  $f12
        sw       $t0,  32+\dst
        sw       $t2,  48+\dst
        packsswh $f8,  $f8,  $f8
        packsswh $f10, $f10, $f10
        mfc1     $t0,  $f8
        mfc1     $t2,  $f10
        sw       $t0,  64+\dst
        sw       $t2,  80+\dst
.endm

.macro DC_COND_ROW_IDCT src0, src4, src1, src5, dst
        ld       $t0,  \src0
        ld       $t2,  \src4
        ld       $t4,  \src1
        ld       $t6,  \src5
        dmtc1    $t0,  $f0
        dmtc1    $t2,  $f2
        dmtc1    $t4,  $f4
        dmtc1    $t6,  $f6
        li       $t0,  0xFFFF0000
        mtc1     $t0,  $f8
        mtc1     $t0,  $f9
        and      $f8,  $f8,  $f0
        or       $f8,  $f8,  $f2
        or       $f8,  $f8,  $f4
        or       $f8,  $f8,  $f6
        packsswh $f8,  $f8,  $f8
        mfc1     $t0,  $f8
        beq      $t0,  $0,   1f
        nop
        ld       $t0,  16($t9)
        dmtc1    $t0,  $f8
        pmaddhw  $f8,  $f8,  $f0
        ld       $t2,  24($t9)
        dmtc1    $t2,  $f10
        pmaddhw  $f0,  $f0,  $f10
        ld       $t0,  32($t9)
        dmtc1    $t0,  $f10
        pmaddhw  $f10, $f10, $f2
        ld       $t2,  40($t9)
        dmtc1    $t2,  $f12
        pmaddhw  $f2,  $f2,  $f12
        ld       $t0,  48($t9)
        dmtc1    $t0,  $f14
        pmaddhw  $f14, $f14, $f4
        ld       $t2,    ($t9)
        dmtc1    $t2,  $f16
        paddw    $f8,  $f8,  $f16
        psubw    $f12, $f8,  $f10
        paddw    $f8,  $f8,  $f10
        ld       $t0,  56($t9)
        dmtc1    $t0,  $f10
        pmaddhw  $f10, $f10, $f6
        paddw    $f0,  $f0,  $f16
        paddw    $f2,  $f2,  $f0
        paddw    $f0,  $f0,  $f0
        psubw    $f0,  $f0,  $f2
        ld       $t0,  64($t9)
        dmtc1    $t0,  $f16
        pmaddhw  $f4,  $f4,  $f16
        paddw    $f14, $f14, $f10
        ld       $t2,  72($t9)
        dmtc1    $t2,  $f10
        pmaddhw  $f10, $f10, $f6
        paddw    $f14, $f14, $f8
        paddw    $f8,  $f8,  $f8
        psubw    $f8,  $f8,  $f14
        paddw    $f10, $f10, $f4
        psraw    $f14, $f14, $f18
        psraw    $f8,  $f8,  $f18
        psubw    $f4,  $f2,  $f10
        paddw    $f2,  $f2,  $f10
        psraw    $f4,  $f4,  $f18
        psraw    $f2,  $f2,  $f18
        packsswh $f14, $f14, $f2
        packsswh $f4,  $f4,  $f8
        dmfc1    $t0,  $f14
        sd       $t0,  \dst
        ld       $t2,  \src1
        dmtc1    $t2,  $f2
        ld       $t4,  80($t9)
        dmtc1    $t4,  $f8
        dmfc1    $t0,  $f4
        sd       $t0,  24+\dst
        pmaddhw  $f8,  $f8,  $f2
        ld       $t2,  88($t9)
        dmtc1    $t2,  $f14
        ld       $t4,  96($t9)
        dmtc1    $t4,  $f20
        pmaddhw  $f2,  $f2,  $f20
        pmaddhw  $f14, $f14, $f6
        ld       $t2,  104($t9)
        dmtc1    $t2,  $f20
        pmaddhw  $f6,  $f6,  $f20
        paddw    $f8,  $f8,  $f14
        paddw    $f4,  $f0,  $f8
        psubw    $f0,  $f0,  $f8
        psraw    $f4,  $f4,  $f18
        psraw    $f0,  $f0,  $f18
        paddw    $f6,  $f6,  $f2
        psubw    $f8,  $f12, $f6
        paddw    $f12, $f12, $f6
        psraw    $f12, $f12, $f18
        packsswh $f4,  $f4,  $f12
        dmfc1    $t0,  $f4
        sd       $t0,  8+\dst
        psraw    $f8,  $f8,  $f18
        packsswh $f8,  $f8,  $f0
        dmfc1    $t2,  $f8
        sd       $t2,  16+\dst
        b        2f
        nop
1:      li       $t1,  16
        mtc1     $t1,  $f22
        psllw    $f0,  $f0,  $f22
        li       $t1,  13
        mtc1     $t1,  $f20
        psraw    $f0,  $f0,  $f20
        packsswh $f0,  $f0,  $f0
        dmfc1    $t0,  $f0
        sd       $t0,     \dst
        sd       $t0,   8+\dst
        sd       $t0,  16+\dst
        sd       $t0,  24+\dst
2:
.endm

function simple_idct_loongson
        .frame   $sp,256,$31
        .mask    0x00000000,0
        .fmask   0x00000000,0                                                                                                   

        addiu    $t8,  $sp,  -256
        li       $t0,  11
        mtc1     $t0,  $f18
        la       $t9,  coeffs

        ROW_IDCT   0($a0),  8($a0), 16($a0), 24($a0),  0($t8)
DC_COND_ROW_IDCT  32($a0), 40($a0), 48($a0), 56($a0), 32($t8)
DC_COND_ROW_IDCT  64($a0), 72($a0), 80($a0), 88($a0), 64($t8)
DC_COND_ROW_IDCT  96($a0),104($a0),112($a0),120($a0), 96($t8)
        li       $t0,  20
        mtc1     $t0,  $f18
COL_IDCT   0($t8), 64($t8), 32($t8),  96($t8),  0($a0)
COL_IDCT   8($t8), 72($t8), 40($t8), 104($t8),  4($a0)
COL_IDCT  16($t8), 80($t8), 48($t8), 112($t8),  8($a0)
COL_IDCT  24($t8), 88($t8), 56($t8), 120($t8), 12($a0)
        j       $31
        nop
.end simple_idct_loongson

        .data
#define C0 23170 //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C1 22725 //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C2 21407 //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C3 19266 //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C4 16383 //cos(i*M_PI/16)*sqrt(2)*(1<<14) - 0.5
#define C5 12873 //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C6 8867  //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5
#define C7 4520  //cos(i*M_PI/16)*sqrt(2)*(1<<14) + 0.5

        .align 3
        .type coeffs, @object
coeffs:
        .short 0x400, 0, 0x400, 0, 0x400, 1, 0x400, 0
        .short  C4,  C4,  C4,  C4,  C4, -C4,  C4, -C4
        .short  C2,  C6,  C2,  C6,  C6, -C2,  C6, -C2
        .short  C1,  C3,  C1,  C3,  C5,  C7,  C5,  C7
        .short  C3, -C7,  C3, -C7, -C1, -C5, -C1, -C5
        .short  C5, -C1,  C5, -C1,  C7,  C3,  C7,  C3
        .short  C7, -C5,  C7, -C5,  C3, -C1,  C3, -C1

